<!-------------------------------------------------------------------------------
 * Copyright (c) 2020 Contributors to the Eclipse Foundation
 *
 * See the NOTICE file(s) distributed with this work for additional
 * information regarding copyright ownership.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0
 *
 * SPDX-License-Identifier: EPL-2.0
 -------------------------------------------------------------------------------->

<app-file-preview
  *ngIf="file$ | async"
  [appFile]="file$ | async"
  class="pdf-overlay">
</app-file-preview>

<app-statement-editor-side-menu
  (appCompile)="compile()"
  (appCompleteFinalization)="finalize($event)"
  (appSave)="submit()"
  (appSaveAndCompleteTask)="submit({ completeTask: $event.variables, claimNext: $event.claimNext})"
  (appSaveAndContribute)="submit({ contribute: true })"
  (appSaveAndFinalize)="submit({ compile: true })"
  (appValidate)="validate()"
  [appForFinalization]="(file$ | async) != null"
  [appLoading]="isStatementLoading$ | async"
  [appTask]="task$ | async"
  [appErrorMessage]="(error$ | async)?.errorMessage"
  [appUserRoles]="userRoles$ | async"
  [showClaimDetails]="configuration.claimDetails?.displayClaimDetails && !initializing"
  [claimDetails]="claimDetails$ | async">
</app-statement-editor-side-menu>

<app-statement-details-information
  [appContactInfo]="(statement$ | async)?.contactInfo"
  [appStatementInfo]="(statement$ | async)?.info"
  [appCollapsed]="true"
  class="statement-details">
</app-statement-details-information>

<app-statement-details-attachments
  [appCollapsed]="true"
  class="statement-details">
</app-statement-details-attachments>

<ng-container *ngIf="(showContributions$ | async) === true">

  <app-collapsible
    *ngIf="(showContributionsControl$ | async) === true"
    [appTitle]="('statementEditorForm.container.contributionStatus' | translate)
     + ' (' + (selectedContributionsCount$ | async) + '/' + (requiredContributionOptions$ | async)?.length + ')'"
    [formGroup]="appFormGroup">

    <app-select-group
      *ngIf="(requiredContributionOptions$ | async)?.length > 0"
      [appGroups]="requiredContributionGroups$ | async"
      [appOptions]="requiredContributionOptions$ | async"
      [formControlName]="'contributions'"
      style="padding: 1em;">
    </app-select-group>

    <div *ngIf="!((requiredContributionOptions$ | async)?.length > 0)"
         class="placeholder">
      {{"details.contributions.placeholder" | translate}}
    </div>
  </app-collapsible>

  <app-statement-details-contributions
    *ngIf="(showContributionsControl$ | async) === false"
    class="statement-details">
  </app-statement-details-contributions>

</ng-container>

<app-comments-form
  class="statement-details"
  [appCollapsed]="true">
</app-comments-form>

<app-collapsible
  [appHeaderTemplateRef]="arrangementHeaderRef"
  [appTitle]="'statementEditorForm.container.draft' | translate"
  [formGroup]="appFormGroup">

  <app-arrangement-form-group
    [appControls]="controls$ | async"
    [appFormGroup]="appFormGroup"
    [appSelectedTextBlockIds]="selectedTextBlockIds$ | async"
    [appShortMode]="appShortMode"
    [appShowPreview]="appShowPreview"
    [appReplacements]="replacements$ | async"
    [appTextBlockGroups]="textBlockGroups$ | async">
  </app-arrangement-form-group>

</app-collapsible>

<app-collapsible
  [appCollapsed]="false"
  [appTitle]="'statementEditorForm.container.attachments' | translate">

  <app-attachments-form-group
    [appAutoTagIds]="[outboxTagId]"
    [appFormGroup]="appFormGroup | getFormGroup: 'attachments'"
    [appRestrictedTagIds]="[outboxTagId]"
    [appForbiddenTagIds]="[statementTagId]"
    [appWithoutTagControl]="true">
  </app-attachments-form-group>

</app-collapsible>

<ng-template #arrangementHeaderRef>
  <div class="editor--arrangement--header">
    <button (click)="appShortMode = !appShortMode"
            class="openk-button editor--arrangement--header--button" type="button">
      <mat-icon class="editor--arrangement--header--button--icon">
        {{appShortMode ? "unfold_more" : "unfold_less"}}
      </mat-icon>
    </button>

    <button (click)="appShowPreview = !appShowPreview"
            class="openk-button editor--arrangement--header--button" type="button">
      <mat-icon class="editor--arrangement--header--button--icon">
        {{appShowPreview ? "chevron_right" : "chevron_left"}}
      </mat-icon>
    </button>
  </div>

</ng-template>
